SystemOrganization addCategory: #SourceCity!
SystemOrganization addCategory: #'SourceCity-Importer'!
SystemOrganization addCategory: #'SourceCity-OpenGL'!
SystemOrganization addCategory: #'SourceCity-Tools'!
SystemOrganization addCategory: #'SourceCity-Core'!

NBExternalStructure variableByteSubclass: #GLCityStructure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!GLCityStructure class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 13:38'!
fieldsDesc
  ^ #( 
         float r;
         float g;
         float b;
         float a;
        )! !

NBExternalStructure variableByteSubclass: #GLFloatRGBA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!GLFloatRGBA class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 16:13'!
fieldsDesc
  ^ #( 
         NBGLFloat r;
         NBGLFloat g;
         NBGLFloat b;  
	   NBGLFloat a;      
        )! !

NBExternalStructure variableByteSubclass: #GLFloatShinines
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!GLFloatShinines class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 16:13'!
fieldsDesc
  ^ #( 
         NBGLFloat  r;
        )! !

NBExternalStructure variableByteSubclass: #GLFloatVector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!GLFloatVector commentStamp: '<historical>' prior: 0!
For initializing x, y, z!

!GLFloatVector class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 16:14'!
fieldsDesc
  ^ #( 
         NBGLFloat x;
         NBGLFloat y;
         NBGLFloat z;  
        )! !

TestCase subclass: #BuildingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Core'!

!BuildingTest methodsFor: 'tests' stamp: 'DouailleErwan 5/15/2012 10:24'!
testHeightMetricsConfig
	"self debug: #testMetricsConfig"
	
	| p d c |
	c := CityImporter new.
	c cityNamed: 'CodCT' withPackageNames: #('AST-Core').
	
	self assert: c city districts size =1.
	self assert: (c city districts at: 1)buildings size =2.
	
	self assert: (c city districts at:1) width = 2.! !

!BuildingTest methodsFor: 'tests' stamp: 'DouailleErwan 5/15/2012 10:23'!
testWidthMetricsConfig
	"self debug: #testMetricsConfig"
	
	| p d c |
	c := CityImporter new.
	c cityNamed: 'CodCT' withPackageNames: #('AST-Core').
	
	self assert: c city districts size =1.
	self assert: (c city districts at: 1)buildings size = 2.! !

TestCase subclass: #CityImporterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Importer'!

!CityImporterTest methodsFor: 'tests' stamp: 'StephaneDucasse 5/14/2012 11:45'!
testDisplayFullyImportOfRing
	"self debug: #testFullyImportOfRing"
	
	| cimport build height |
	cimport := CityImporter new.
	cimport cityNamed: 'CodCT' withPackageNames: (RPackageOrganizer default packageNames).
	build := 0.
	height := 0.
	(cimport city districts) do:[:each|
		(each buildings) do:[:eachClass|
			build := build+1.
			].
		].
	Transcript clear;show:'1 ville - ';show:cimport city districts size;show: ' districts - ';show: build;show:' buildings le plus haut fait : ';show:height.! !

!CityImporterTest methodsFor: 'tests' stamp: 'StephaneDucasse 5/14/2012 11:45'!
testFullyImportOfRing
	"self debug: #testFullyImportOfRing"
	"This method test, is just for show us what does normal import realize. How many build, districts ... and max metrics we can find"
	| cimport ring build height |
	cimport := CityImporter new.
	cimport cityNamed: 'CodCT' withPackageNames: (RPackageOrganizer default packageNames).
	
	"self assert: cimport city districts size = 481.
	self assert: (cimport city hasDistrictNamed: #'AST-Core').
	self assert: (cimport city hasDistrictNamed: #'SourceCity')."
	"Transcript cr;show:cimport city size."
	build := 0.
	height := 0.
	(cimport city districts) do:[:each|
		(each buildings) do:[:eachClass|
			build := build+1.
			].
		].
	Transcript clear;show:'1 ville - ';show:cimport city districts size;show: ' districts - ';show: build;show:' buildings le plus haut fait : ';show:height.
	"Transcript cr;show: (RPackage new numberOfClasses)."! !

!CityImporterTest methodsFor: 'tests' stamp: 'StephaneDucasse 5/14/2012 11:45'!
testImportClassAsBuilding
	"self debug: #testImportClassAsBuilding"
	
	| cimport |
	cimport := CityImporter new.
	cimport cityNamed: 'CodCT' withPackageNames: #('AST-Core' ).
	self assert: cimport city districts size = cimport numberOfDistrict .
	self assert: (cimport city hasDistrictNamed: #'AST-Core').
	
	self assert: cimport city districts size = cimport numberOfDistrict .
	self assert: (cimport city hasDistrictNamed: #'AST-Core').
	self assert: (cimport city districts at: 1)buildings size = cimport numberOfBuilding.
	
	! !

!CityImporterTest methodsFor: 'tests' stamp: 'StephaneDucasse 5/14/2012 11:45'!
testImportPackageAsDistrict
	"self debug: #testImportPackageAsDistrict"
	
	| cimport |
	cimport := CityImporter new.
	cimport cityNamed: 'CodCT' withPackageNames: #('AST-Core' ).
	self assert: cimport city districts size = cimport numberOfDistrict .
	self assert: (cimport city hasDistrictNamed: #'AST-Core').
	! !

!CityImporterTest methodsFor: 'tests' stamp: 'StephaneDucasse 5/14/2012 11:45'!
testImportPackageAsDistrictNoDuplicate
	"self debug: #testImportPackageAsDistrictNoDuplicate"
	
	| cimport |
	cimport := CityImporter new.
	cimport cityNamed: 'CodCT' withPackageNames: #('AST-Core'  'AST-Core').
	self assert: cimport city districts size = cimport numberOfDistrict .
	self assert: (cimport city hasDistrictNamed: #'AST-Core').
	! !

TestCase subclass: #DistrictTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Core'!

!DistrictTest methodsFor: 'tests' stamp: 'DouailleErwan 5/15/2012 10:22'!
testMetricsConfig
	"self debug: #testMetricsConfig"
	
	| p d c |
	c := CityImporter new.
	c cityNamed: 'CodCT' withPackageNames: #('AST-Core').
	self assert: c city districts size =1.! !

!Float methodsFor: '*SourceCity' stamp: 'douaille 4/10/2012 14:35'!
roundedUp
	"Return a rounded up"
	self fractionPart abs = 0.0
	ifTrue: [
		^self truncated
		]
	ifFalse: [
		^self truncated + self sign rounded
		]! !

GLViewportMorph subclass: #GLCity
	instanceVariableNames: 'rotationAngle textId xrot yrot zrot face top down xtran ytran ztran znumb ynumb xnumb grass model frameCount font frameStats start configuration lastMousePosition curveRenderer glyphCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!GLCity commentStamp: '<historical>' prior: 0!
A GLCity is a class which display the city with OpenGL, this class use camera and key handler!

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 4/25/2012 15:34'!
applyCamera
	display gl translatef_x: xtran y: ytran z: ztran. 
	display gl  rotatef_angle: configuration cameraXPos x: 1 y: 0  z: 0. 
	display gl rotatef_angle: configuration cameraYPos x: 0 y: 1  z: 0. 
	display gl rotatef_angle: configuration cameraZPos x: 0 y: 1  z: 0. 
! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 4/27/2012 11:42'!
building: anArray
	|gl x z y |
	
	gl := display gl.
	gl enable: GL_TEXTURE_2D.
	
	gl bindTexture_target: GL_TEXTURE_2D texture: face. 	
	gl begin: GL_QUADS.
	
		"front"
		self vertex: { anArray first . 0 . anArray third } texCoord: #(0 0).
		self vertex: { anArray first . anArray second . anArray third } texCoord: #(1 0).
		self vertex: { (anArray first)+1 . anArray second . anArray third } texCoord: #(1 1).
		self vertex: { (anArray first)+1 . 0 . anArray third } texCoord: #(0 1).
		
		"back"
		self vertex: { anArray first . 0 . (anArray third)+1 } texCoord: #(0 0).
		self vertex: { (anArray first)+1 . 0 . (anArray third)+1 } texCoord: #(1 0).
		self vertex: { (anArray first)+1 . anArray second . (anArray third)+1 } texCoord: #(1 1).
		self vertex: { anArray first . anArray second . (anArray third)+1 } texCoord: #(0 1).
	
		"left maybe reverse with right"
		self vertex: { (anArray first)+1 . 0 . anArray third } texCoord: #(0 0).
		self vertex: { (anArray first)+1 . anArray second . anArray third } texCoord: #(1 0).
		self vertex: { (anArray first)+1 . anArray second . (anArray third)+1 } texCoord: #(1 1).
		self vertex: { (anArray first)+1 . 0 . (anArray third)+1 } texCoord: #(0 1).
	
		"right maybe reverse with left"
		self vertex: { anArray first . 0 . (anArray third)+1 } texCoord: #(0 0).
		self vertex: { anArray first . anArray second . (anArray third)+1 } texCoord: #(1 0).
		self vertex: { anArray first . anArray second . anArray third } texCoord: #(1 1).
		self vertex: { anArray first . 0 . anArray third } texCoord: #(0 1).
		
	gl end.
	
	gl bindTexture_target: GL_TEXTURE_2D texture: down.
	gl begin: GL_QUADS.
		"down"
		self vertex: { anArray first . 0 . anArray third } texCoord: #(0 0).
		self vertex: { (anArray first)+1 . 0 . anArray third } texCoord: #(1 0).
		self vertex: { (anArray first)+1 . 0 . (anArray third)+1 } texCoord: #(1 1).
		self vertex: { anArray first . 0 . (anArray third)+1 } texCoord: #(0 1).
	gl end.
	
	gl bindTexture_target: GL_TEXTURE_2D texture: top. 		
	gl begin: GL_QUADS.	
		"top"
		self vertex: { anArray first . anArray second . anArray third } texCoord: #(0 0).
		self vertex: { anArray first . anArray second . (anArray third)+1 } texCoord: #(1 0).
		self vertex: { (anArray first)+1 . anArray second . (anArray third)+1 } texCoord: #(1 1).
		self vertex: { (anArray first)+1 . anArray second . anArray third } texCoord: #(0 1).
	gl end.! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwans 5/2/2012 11:06'!
buildingColor: anArray color: aColor
		self buildingColor: anArray color: aColor width: 1! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 5/12/2012 11:21'!
buildingColor: anArray color: aColor width: aWidthSelector
		self drawFace: anArray color: aColor width: aWidthSelector.
		self drawBack: anArray color: aColor width: aWidthSelector.
		self drawLeft: anArray color: aColor width: aWidthSelector.
		self drawRight: anArray color: aColor width: aWidthSelector.
		self drawDown: anArray color: aColor width: aWidthSelector.
		self drawTop: anArray color: aColor width: aWidthSelector.
		self drawBorder: anArray width: aWidthSelector.! !

!GLCity methodsFor: 'control' stamp: 'DouailleErwan 4/17/2012 19:35'!
captureKey: e

	(e keyString = '<left>')
		ifTrue:[ self rotateLeft].
	(e keyString  = '<down>')
		ifTrue:[self rotateDown].
	(e keyString  = '<up>')
		ifTrue:[self rotateTop].
	(e keyString  = '<right>')
		ifTrue:[self rotateRight].
	(e keyString  = '<Shift-right>')
		ifTrue:[self translateRight].
	(e keyString  = '<Shift-left>')
		ifTrue:[self translateLeft].
	(e keyString  = '<Shift-up>')
		ifTrue:[self translateTop].
	(e keyString  = '<Shift-down>')
		ifTrue:[self translateDown].
	(e keyString  = ' ')
		ifTrue:[self translateForward].
	(e keyString  = '<' )
		ifTrue:[self translateBackward].! !

!GLCity methodsFor: 'control' stamp: 'DouailleErwan 5/7/2012 14:33'!
captureMouse: e
	(self lastMousePosition x > (e position - self position) x)
		ifTrue: [self rotateLeft].
	(self lastMousePosition x < (e position - self position) x)
		ifTrue:[self rotateRight].
	(self lastMousePosition y < (e position - self position) y)
		ifTrue:[self rotateTop].
	(self lastMousePosition y > (e position - self position) y)
		ifTrue:[self rotateDown].
	self lastMousePosition: (e position - self position).! !

!GLCity methodsFor: 'control' stamp: 'DouailleErwan 5/15/2012 11:30'!
captureMouseDown: e
	Transcript cr;show: configuration cameraXPos ;cr;show: configuration cameraYPos ;cr;show: configuration cameraZPos .

"
	|hits selectBuf viewport gl x y  size |
	 x := (e position x) - self position x.
	 y := (e position y) - self position y.
	selectBuf := ByteArray new: 8 * 512.
	hits := ByteArray new: 4 * 1.
	viewport := ByteArray new: 4 * 4.
	
	Transcript cr;show:'Position souris :', x asString, ' - ', y asString.
	
	gl := display gl.
	gl getIntegerv_pname: GL_VIEWPORT  params: viewport.
	gl selectBuffer_size: 512 buffer: selectBuf.
	gl renderMode: GL_SELECT.
	gl initNames.
	gl pushName: 0.
	gl matrixMode: GL_PROJECTION.
	gl pushMatrix.		
	gl loadIdentity.
	self myGluPickMatrix_x: x y: ((viewport nbLongAt: 1+12)-y) deltax: 5 deltay: 5 viewport: viewport. 
	gl ortho_left: 0 right: 3 bottom: 0 top: 3 zNear: -1 zFar: 1. 
	
	self drawCity: model.
	
	gl matrixMode: GL_PROJECTION.
	gl popMatrix.
	gl flush.
	hits := (gl renderMode: GL_RENDER).
	Transcript cr;show: hits."
	
! !

!GLCity methodsFor: 'control' stamp: 'DouailleErwan 5/9/2012 10:37'!
captureMouseStillDown: e
	(self lastMousePosition x > (e position - self position) x)
		ifTrue: [self rotateLeft].
	(self lastMousePosition x < (e position - self position) x)
		ifTrue:[self rotateRight].
	(self lastMousePosition y < (e position - self position) y)
		ifTrue:[self rotateTop].
	(self lastMousePosition y > (e position - self position) y)
		ifTrue:[self rotateDown].
	self lastMousePosition: (e position - self position).! !

!GLCity methodsFor: 'control' stamp: 'DouailleErwan 5/7/2012 14:48'!
captureMouseWheel: e
	e direction = #up 
		ifTrue:[self translateForward].
	e direction = #down 
		ifTrue:[self translateBackward].! !

!GLCity methodsFor: 'accessing' stamp: 'DouailleErwan 5/3/2012 16:25'!
changeConfiguration: aCityConfiguration
	configuration := aCityConfiguration.
	model := configuration model.! !

!GLCity methodsFor: 'accessing' stamp: 'DouailleErwan 4/16/2012 10:48'!
changeModel: aNewRing
	model := aNewRing! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 4/17/2012 17:25'!
city: anArrayStart to: anArrayEnd
	|gl|
	
	gl := display gl.
	gl enable: GL_TEXTURE_2D.
	
	gl bindTexture_target: GL_TEXTURE_2D texture: city. 			
	gl begin: GL_QUADS.
		
		self vertex: { anArrayStart first . anArrayStart second . anArrayStart third } texCoord: #(0 0).
		self vertex: { anArrayEnd first . anArrayStart second . anArrayStart third } texCoord: #(1 0).
		self vertex: { anArrayEnd first . anArrayStart second . anArrayEnd third } texCoord: #(1 1).
		self vertex: { anArrayStart first . anArrayStart second . anArrayEnd third } texCoord: #(0 1).

	gl end.
	! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 5/2/2012 15:06'!
cityColor: anArrayStart to: anArrayEnd color: aColor
	|gl|
	gl := display gl.	
	gl begin: GL_QUADS;
		color3f_red: aColor red green: aColor green blue: aColor blue; 
		vertex3d_x: anArrayStart first y: anArrayStart second z: anArrayStart third;
		vertex3d_x: anArrayEnd first y: anArrayStart second z: anArrayStart third;
		vertex3d_x: anArrayEnd first y: anArrayStart second z: anArrayEnd third;
		vertex3d_x: anArrayStart first y: anArrayStart second z: anArrayEnd third;
	end.
	! !

!GLCity methodsFor: 'drawing' stamp: 'StephaneDucasse 5/14/2012 11:29'!
colorChoice: aBuilding
		"Transcript cr; show: aBuilding heightSelector asInteger; show: ' - ';show: configuration buildingMediumHeightColor."
		(aBuilding height > configuration buildingMediumHeightColor)
		ifTrue: [
			(aBuilding height > configuration buildingMaxHeightColor)
			ifTrue: [
				^configuration buildingHighColor.
			]
			ifFalse:[
				^configuration buildingMediumColor.
			].
		]
		ifFalse: [
			^configuration buildingLowColor.
			].! !

!GLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/16/2012 10:19'!
cubicMatrix
	^ThreeDimensionalMatrix new
	 add: {-1. -1. 1};
	 add: {1. -1. 1};
	 add: {1. 1. 1};
	 add: {-1. 1. 1};
	
	 add: {-1. -1. -1};
	 add: {-1. 1. -1};
	 add: {1. 1. -1};
	 add: {1.-1. -1};
	
	  add: {-1. 1. -1};
	  add: {-1. 1. 1};
	  add: {1. 1. 1};
	  add: {1. 1. -1};
	
	  add: {-1. -1. -1};
	  add: {1. -1. -1};
	  add: {1. -1. 1};
	  add: {-1. -1. 1};
	
	  add: {1. -1. -1};
	  add: {1. 1. -1};
	  add: {1. 1. 1};
	  add: {1. -1. 1};
	
	  add: {-1. -1. -1};
	  add: {-1. -1. 1};
	  add: {-1. 1. 1};
	  add: {-1. 1. -1};
	yourself! !

!GLCity methodsFor: 'initialize' stamp: 'DouailleErwan 4/27/2012 16:05'!
default: aCityConfiguration
	configuration := aCityConfiguration.
	model := configuration model.
	xtran := 0.
	ytran := 30.
	ztran := -384.
	self on: #keyStroke send: #captureKey: to: self.
	! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 4/17/2012 17:24'!
district: anArrayStart to: anArrayEnd
	|gl|
	gl := display gl.
	gl enable: GL_TEXTURE_2D.
	gl bindTexture_target: GL_TEXTURE_2D texture: district. 	
	gl begin: GL_QUADS.

		self vertex: { anArrayStart first . anArrayStart second . anArrayStart third } texCoord: #(0 0).
		self vertex: { anArrayEnd first . anArrayStart second . anArrayStart third } texCoord: #(1 0).
		self vertex: { anArrayEnd first . anArrayStart second . anArrayEnd third } texCoord: #(1 1).
		self vertex: { anArrayStart first . anArrayStart second . anArrayEnd third } texCoord: #(0 1).
		
		self vertex: { anArrayStart first . anArrayEnd second . anArrayStart third } texCoord: #(0 0).
		self vertex: { anArrayStart first . anArrayEnd second . anArrayEnd third } texCoord: #(1 0).
		self vertex: { anArrayEnd first . anArrayEnd second . anArrayEnd third } texCoord: #(1 1).
		self vertex: { anArrayEnd first . anArrayEnd second . anArrayStart third } texCoord: #(0 1).

	gl end.	! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 5/15/2012 12:46'!
districtColor: anArrayStart to: anArrayEnd color: aColor
	|gl|
	gl := display gl.
	gl begin: GL_QUADS;
		color3f_red: aColor red green: aColor green blue: aColor blue; 
		vertex3d_x: anArrayStart first y: anArrayStart second z: anArrayStart third;
		vertex3d_x: anArrayEnd first y: anArrayStart second z: anArrayStart third;
		vertex3d_x: anArrayEnd first y: anArrayStart second z: anArrayEnd third;
		vertex3d_x: anArrayStart first y: anArrayStart second z: anArrayEnd third;
	end.! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 5/1/2012 18:29'!
drawBack: anArray color: aColor width: aWidthSelector
	|gl x z y minColor |
	minColor:= configuration buildingLowColor.
	gl := display gl.
	gl begin: GL_QUADS;
		color3f_red: minColor red green: minColor green blue: minColor blue; 
		vertex3d_x:  anArray first y: 0.1 z: (anArray third)+aWidthSelector;
		vertex3d_x:  (anArray first)+aWidthSelector y: 0.1 z: (anArray third)+aWidthSelector;
		color3f_red: aColor red green: aColor green blue: aColor blue; 
		vertex3d_x:  (anArray first)+aWidthSelector y: anArray second z: (anArray third)+aWidthSelector;
		vertex3d_x:  anArray first y: anArray second z: (anArray third)+aWidthSelector;
	end.! !

!GLCity methodsFor: 'testing' stamp: 'DouailleErwan 5/11/2012 10:43'!
drawBorder: anArray 
	|gl|
	gl := display gl.
	gl begin: GL_LINES;

		color3f_red: 0 green: 0 blue: 0; 
		vertex3f_x: anArray first y: 0.1 z: anArray third;
		vertex3f_x: anArray first y: anArray second z: anArray third;
		
	end.
	! !

!GLCity methodsFor: 'testing' stamp: 'DouailleErwan 5/11/2012 11:22'!
drawBorder: anArray width: aWidthSelector
	|gl|
	gl := display gl.
	gl begin: GL_LINES;

		color3f_red: 0 green: 0 blue: 0; 
		vertex3f_x: anArray first y: 0.1 z: anArray third;
		vertex3f_x: anArray first y: anArray second z: anArray third;
		
		vertex3f_x: anArray first y: 0.1 z: (anArray third)+aWidthSelector;
		vertex3f_x: anArray first y: anArray second z: (anArray third)+aWidthSelector;
		
		vertex3f_x: (anArray first)+aWidthSelector y: anArray second z: anArray third;
		vertex3f_x: (anArray first)+aWidthSelector y: 0.1 z: anArray third;
		
		vertex3f_x: (anArray first)+aWidthSelector y: 0.1 z: (anArray third)+aWidthSelector;
		vertex3f_x: (anArray first)+aWidthSelector y: anArray second z: (anArray third)+aWidthSelector;
		
		vertex3f_x: anArray first y: 0.1 z: anArray third;
		vertex3f_x: anArray first y: 0.1 z: (anArray third)+aWidthSelector;
		
		vertex3f_x: anArray first y: anArray second z: anArray third;
		vertex3f_x: anArray first y: anArray second z: (anArray third)+aWidthSelector;
		
		vertex3f_x: (anArray first)+aWidthSelector y: anArray second z: anArray third;
		vertex3f_x: (anArray first)+aWidthSelector y: anArray second z: (anArray third)+aWidthSelector;
		
		vertex3f_x: (anArray first)+aWidthSelector y: 0.1 z: anArray third;
		vertex3f_x: (anArray first)+aWidthSelector y: 0.1 z: (anArray third)+aWidthSelector;
		
		vertex3f_x: anArray first y: anArray second z: anArray third;
		vertex3f_x: (anArray first)+aWidthSelector y: anArray second z: anArray third;
		
		vertex3f_x: anArray first y: 0.1 z: anArray third;
		vertex3f_x: (anArray first)+aWidthSelector y: 0.1 z: anArray third;
		
		vertex3f_x: anArray first y: anArray second z: (anArray third)+aWidthSelector;
		vertex3f_x: (anArray first)+aWidthSelector y: anArray second z: (anArray third)+aWidthSelector;
		
		vertex3f_x: anArray first y: 0.1 z: (anArray third)+aWidthSelector;
		vertex3f_x: (anArray first)+aWidthSelector y: 0.1 z: (anArray third)+aWidthSelector;
		
	end.! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 5/15/2012 11:27'!
drawBuilding: aDistrict gap: buildingGap x: x z: z dxSize: dxSize

	| bxSize bzSize bColor zmax |
	bColor := Color new. 
	bxSize := x +1 .
	bzSize := z +1.
	zmax := 0.
	aDistrict buildings do: [:building |
		bColor := self colorChoice: building.
		(dxSize < (bxSize+ (building width)))
		ifTrue: [
			bzSize := bzSize + zmax + buildingGap.
			zmax := building width.
			bxSize := x + 1 + (building width).
			self buildingColor: { x+1 . (building height) . bzSize } color: bColor width: (building width).
			bxSize := bxSize + buildingGap.
			]
		ifFalse: [
			(zmax<(building width))
			ifTrue:[zmax := (building width)].
				self buildingColor: { bxSize . (building height) . bzSize } color: bColor width: (building width).
				bxSize := bxSize + buildingGap + (building width).
			].
	].
	^bzSize+zmax+1.! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 5/15/2012 11:07'!
drawBuilding: aDistrict x: x z: z dxSize: dxSize

	| bxSize bzSize bColor zmax |
	bColor := Color new. 
	bxSize := x +1 .
	bzSize := z +1.
	zmax := 0.
	aDistrict buildings do: [:building |
		bColor := self colorChoice: building.
		(dxSize < (bxSize+ (building width)))
		ifTrue: [
			bzSize := bzSize + zmax + configuration buildingGap.
			zmax := building width.
			bxSize := x + (building width).
			self buildingColor: { x+1 . (building height) . bzSize } color: bColor width: (building width).
			bxSize := bxSize + configuration buildingGap.
			]
		ifFalse: [
			(zmax<(building width))
			ifTrue:[zmax := (building width)].
			self buildingColor: { bxSize . (building height) . bzSize } color: bColor width: (building width).
			bxSize := bxSize + configuration buildingGap + (building width).
			].
	].
	^bzSize+zmax+1.! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwans 5/2/2012 11:09'!
drawCity: anImporter
	|sizeArray|
	sizeArray := self drawDistrict: anImporter city gap: configuration districtGap.
	"self city: {-1 . -0.1 . -1} to: sizeArray."
	self cityColor: {-1 . -0.1 . -1} to: sizeArray color: configuration cityColor.! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 5/15/2012 13:34'!
drawDistrict:aCity gap: gap
	| dxSize x dzSize z maxdxSize maxdzSize bxSize bzSize buildingGap |
	x := 0.
	z := 0.
	buildingGap := configuration buildingGap.
	(configuration buildingGap<1)
	ifTrue: [buildingGap := 1.] 
	ifFalse: [buildingGap := configuration buildingGap].
	maxdzSize := 0.
	maxdxSize := 0.
	aCity districts do:[:district |
		dxSize := x + ((district width) *buildingGap+1).
		dzSize := self drawBuilding: district gap: buildingGap x: x z: z dxSize: dxSize.
		"self drawText: district model asString to: {x . 0.5 . z}."
		self districtColor: {x . 0.1 . z} to: {dxSize . 0.1 . dzSize} color: configuration districtColor.
		(maxdzSize < dzSize)
		ifTrue: [ maxdzSize := dzSize].
		x := dxSize + gap.
		( x > aCity width)
		ifTrue: [
			z := maxdzSize + gap.
			(maxdxSize<x)
			ifTrue: [maxdxSize := x+(dxSize - x).].
			x := 0.
		]
		ifFalse: [
			(maxdxSize<x)
			ifTrue: [maxdxSize := x.].
		].
	].
	^{maxdxSize+1 . 0 . maxdzSize+1}! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 5/9/2012 11:31'!
drawDown: anArray color: aColor width: aWidthSelector
	|gl x z y minColor |
	minColor:= configuration buildingLowColor.
	gl := display gl.
	gl enable: GL_NORMALIZE .
	gl begin: GL_QUADS;
		color3f_red: minColor red green: minColor green blue: minColor blue; 
		vertex3d_x:  anArray first y: 0.1 z: anArray third;
		vertex3d_x:  (anArray first)+aWidthSelector y: 0.1 z: anArray third;
		vertex3d_x:  (anArray first)+aWidthSelector y: 0.1 z: (anArray third)+aWidthSelector;
		vertex3d_x:  anArray first y: 0.1 z: (anArray third)+aWidthSelector;
	end.! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 5/15/2012 12:54'!
drawFace: anArray color: aColor width: aWidthSelector
	|gl x z y minColor b n |
	minColor:= configuration buildingLowColor.
	gl := display gl.
	gl begin: GL_QUADS;
		color3f_red: minColor red green: minColor green blue: minColor blue; 
		vertex3d_x: anArray first y: 0.1 z: anArray third;
		color3f_red: aColor red green: aColor green blue: aColor blue; 
		vertex3d_x: anArray first y: anArray second z: anArray third;
		vertex3d_x: (anArray first)+aWidthSelector y: anArray second z: anArray third;
		color3f_red: minColor red green: minColor green blue: minColor blue; 
		vertex3d_x: (anArray first)+aWidthSelector y: 0.1 z: anArray third;
	end.! !

!GLCity methodsFor: 'testing' stamp: 'DouailleErwan 5/1/2012 18:26'!
drawLeft: anArray color: aColor width: aWidthSelector
	|gl x z y minColor |
	minColor:= configuration buildingLowColor.
	gl := display gl.
	gl begin: GL_QUADS;
		color3f_red: minColor red green: minColor green blue: minColor blue; 
		normal3d_nx: 1 ny: 1 nz: 1; 
		vertex3d_x:  (anArray first)+aWidthSelector y: 0.1 z: anArray third;
		color3f_red: aColor red green: aColor green blue: aColor blue; 
		vertex3d_x:  (anArray first)+aWidthSelector y: anArray second z: anArray third;
		vertex3d_x:  (anArray first)+aWidthSelector y: anArray second z: (anArray third)+aWidthSelector;
		color3f_red: minColor red green: minColor green blue: minColor blue; 
		vertex3d_x:  (anArray first)+aWidthSelector y: 0.1 z: (anArray third)+aWidthSelector;
	end.! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 5/1/2012 18:26'!
drawRight: anArray color: aColor width: aWidthSelector
	|gl x z y minColor |
	minColor:= configuration buildingLowColor.
	gl := display gl.
	gl begin: GL_QUADS;
		color3f_red: minColor red green: minColor green blue: minColor blue; 
		vertex3d_x:  anArray first y: 0.1 z: (anArray third)+aWidthSelector;
		color3f_red: aColor red green: aColor green blue: aColor blue; 
		vertex3d_x:  anArray first y: anArray second z: (anArray third)+aWidthSelector;
		vertex3d_x:  anArray first y: anArray second z: anArray third ;
		color3f_red: minColor red green: minColor green blue: minColor blue; 
		vertex3d_x:  anArray first y: 0.1 z: anArray third ;
		color3f_red: minColor red green: minColor green blue: minColor blue; 
	end.! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 5/15/2012 13:06'!
drawText: aString to: anArray
	| gl x |
	gl := display gl.
	curveRenderer ifNotNil: [  | g adv |
		gl color3f_red: 0 green:  0 blue: 0. 
	"	gl scalef_x: 0.01 y: -0.01  z: 1."
		adv := 0.
		x:=0.
		aString do:  [:ch |
			g := font at: ch.
			glyphCache renderGlyph: g. 
			].
	].! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 5/1/2012 18:27'!
drawTop: anArray color: aColor width: aWidthSelector
	|gl x z y minColor |
	minColor:= configuration buildingLowColor.
	gl := display gl.
	gl begin: GL_QUADS;
		color3f_red: aColor red green: aColor green blue: aColor blue; 
		vertex3d_x: anArray first y: anArray second z: anArray third ;
		vertex3d_x: anArray first y: anArray second z: (anArray third)+aWidthSelector;
		vertex3d_x: (anArray first)+aWidthSelector y: anArray second z: (anArray third)+aWidthSelector;
		vertex3d_x: (anArray first)+aWidthSelector y: anArray second z: anArray third ;
	end.! !

!GLCity methodsFor: 'initialize' stamp: 'DouailleErwan 5/15/2012 12:42'!
initialize
	| fontPath |
	super initialize.
	lastMousePosition := Point x: 0 y:0.
	self on: #keyStroke send: #captureKey: to: self.
	self on: #mouseStillDown send: #captureMouseStillDown: to: self.
	self on: #mouseDown send: #captureMouseDown: to: self.
	
	
	fontPath := self platformDefaultFontsPath.	
	font := NBTTFontReader readFrom:  
		(FileStream readOnlyFileNamed: fontPath , 'Tahoma.ttf').
	! !

!GLCity methodsFor: 'session management' stamp: 'DouailleErwan 4/18/2012 14:33'!
initializeForNewSession
	super initializeForNewSession.
	self loadTexture.
	self loadText.
       curveRenderer := nil.
       (display gl isSupportedExtension: #GL_ARB_fragment_program ) ifTrue: [
               curveRenderer := NBGLCurveRenderer new gl: display gl.
               glyphCache := NBTTFontCache new initialize: curveRenderer.
       ]! !

!GLCity methodsFor: 'accessing' stamp: 'DouailleErwan 5/7/2012 14:22'!
lastMousePosition
	^lastMousePosition! !

!GLCity methodsFor: 'accessing' stamp: 'DouailleErwan 5/7/2012 14:22'!
lastMousePosition: aPoint
	lastMousePosition := aPoint! !

!GLCity methodsFor: 'session management' stamp: 'DouailleErwan 4/18/2012 14:33'!
loadText
       curveRenderer := nil.
       (display gl isSupportedExtension: #GL_ARB_fragment_program ) ifTrue: [
               curveRenderer := NBGLCurveRenderer new gl: display gl.
               glyphCache := NBTTFontCache new initialize: curveRenderer.
       ]! !

!GLCity methodsFor: 'initialize' stamp: 'DouailleErwan 4/17/2012 11:03'!
loadTexture
	
	| buffer fileForm gl fileFormGrass fileFormFace fileFormTop fileFormDown buffer2 buffer3 fileFormDistrict fileFormCity |
	fileFormGrass := (PNGReadWriter formFromFileNamed: 'grass.png').
	fileFormFace := (PNGReadWriter formFromFileNamed: 'bricks.png').
	fileFormTop := (PNGReadWriter formFromFileNamed: 'bricks.png').
	fileFormDown := (PNGReadWriter formFromFileNamed: 'bricks.png').
	fileFormDistrict := (PNGReadWriter formFromFileNamed: 'district.png').
	fileFormCity := (PNGReadWriter formFromFileNamed: 'city.png').
	
	gl := display gl.
	buffer := ByteArray new: 24.	
	gl genTextures_n: 6 textures: buffer.
	 
	face := buffer nbUlongAt: 1. 
	top := buffer nbUlongAt: 5.
	down := buffer nbUlongAt: 9.
	grass := buffer nbUlongAt: 13.
	city := buffer nbUlongAt: 17.
	district := buffer nbUlongAt: 21.
	
	gl bindTexture_target:  GL_TEXTURE_2D texture: face.
	gl texImage2D_target: GL_TEXTURE_2D level: 0 internalformat: 4 width: (fileFormFace width) height: (fileFormFace height)  border: 0  format: GL_BGRA type: GL_UNSIGNED_BYTE pixels: (fileFormFace bits). 
	gl 
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MIN_FILTER param: GL_LINEAR;
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MAG_FILTER param: GL_LINEAR.

	
	gl bindTexture_target:  GL_TEXTURE_2D texture: top.
	gl texImage2D_target: GL_TEXTURE_2D level: 0 internalformat: 4 width: (fileFormTop width) height: (fileFormTop height)  border: 0  format: GL_BGRA type: GL_UNSIGNED_BYTE pixels: (fileFormTop bits). 
	gl 
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MIN_FILTER param: GL_LINEAR;
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MAG_FILTER param: GL_LINEAR.

	gl bindTexture_target:  GL_TEXTURE_2D texture: down.
	gl texImage2D_target: GL_TEXTURE_2D level: 0 internalformat: 4 width: (fileFormDown width) height: (fileFormDown height)  border: 0  format: GL_BGRA type: GL_UNSIGNED_BYTE pixels: (fileFormDown bits). 
	gl 
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MIN_FILTER param: GL_LINEAR;
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MAG_FILTER param: GL_LINEAR.

	gl bindTexture_target:  GL_TEXTURE_2D texture: grass.
	gl texImage2D_target: GL_TEXTURE_2D level: 0 internalformat: 4 width: (fileFormGrass width) height: (fileFormGrass height)  border: 0  format: GL_BGRA type: GL_UNSIGNED_BYTE pixels: (fileFormGrass bits). 
	gl 
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MIN_FILTER param: GL_LINEAR;
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MAG_FILTER param: GL_LINEAR.

	gl bindTexture_target:  GL_TEXTURE_2D texture: city.
	gl texImage2D_target: GL_TEXTURE_2D level: 0 internalformat: 4 width: (fileFormCity width) height: (fileFormCity height)  border: 0  format: GL_BGRA type: GL_UNSIGNED_BYTE pixels: (fileFormCity bits). 
	gl 
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MIN_FILTER param: GL_LINEAR;
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MAG_FILTER param: GL_LINEAR."
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_WRAP_S param: GL_REPEAT;
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_WRAP_T param: GL_REPEAT."

	gl bindTexture_target:  GL_TEXTURE_2D texture: district.
	gl texImage2D_target: GL_TEXTURE_2D level: 0 internalformat: 4 width: (fileFormDistrict width) height: (fileFormDistrict height)  border: 0  format: GL_BGRA type: GL_UNSIGNED_BYTE pixels: (fileFormDistrict bits). 
	gl 
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MIN_FILTER param: GL_LINEAR;
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MAG_FILTER param: GL_LINEAR.

	self assert: (gl getError = GL_NO_ERROR)! !

!GLCity methodsFor: 'control' stamp: 'DouailleErwan 5/11/2012 15:48'!
myGluPickMatrix_x: x y: y deltax: deltax deltay: deltay viewport: viewport
	| floatStruct gl |
	gl := display gl.
	floatStruct := GLFloatVector new.
	
	(deltax = 0 | deltay = 0)
	ifTrue: [^self].
	
	floatStruct x: (((viewport nbLongAt: 1+8) - 2 * ( x - (viewport nbLongAt: 1) )) / deltax) ;y:(((viewport nbLongAt: 1+12)  - 2 * (y - (viewport nbLongAt: 1+4) )) / deltay); z: 0.
	gl translatef_x:floatStruct x y: floatStruct y z: floatStruct z.
	
	floatStruct x: ((viewport nbLongAt: 1+8) / deltax) asFloat;y: ((viewport nbLongAt: 1+12) / deltay) asFloat ;z: 1 asFloat.
	gl scalef_x:floatStruct x y: floatStruct y z: floatStruct z.
! !

!GLCity methodsFor: 'initialize' stamp: 'StephaneDucasse 5/14/2012 12:09'!
openInWorld
	super openInWorld setLabel:'SourceCity'.
	self startStepping.
	self takeKeyboardFocus.! !

!GLCity methodsFor: 'camera' stamp: 'douaille 4/7/2012 16:42'!
perspectiveFovY: fovY aspect: aspect zNear: zNear zFar: zFar
"Replaces gluPerspective. Sets the frustum to perspective mode.
// fovY     - Field of vision in degrees in the y direction
// aspect   - Aspect ratio of the viewport
// zNear    - The near clipping distance
// zFar     - The far clipping distance
 "
	| fW fH |
	fH := (fovY / (360 * Float pi)) tan * zNear.
	"fH = tan( fovY / 360 * pi ) * zNear;"
	fW := fH * aspect.
	display gl frustum_left: fW negated  right:  fW bottom: fH negated top: fH  zNear:  zNear zFar:   zFar! !

!GLCity methodsFor: 'session management' stamp: 'DouailleErwan 4/18/2012 14:33'!
platformDefaultFontsPath

	NativeBoost platformId == NativeBoostConstants win32PlatformId ifTrue: [
		^ 'C:\Windows\Fonts\'
		].
	
	NativeBoost platformId == NativeBoostConstants mac32PlaformId ifTrue: [
		^ '/Library/Fonts/'
		].
! !

!GLCity methodsFor: 'rendering' stamp: 'DouailleErwan 5/15/2012 13:04'!
render

	| gl specular shinines l_pos l_color lmodel_ambient t fog_color diffuse spot target |
	self checkSession.
	
	"WORK !!!!!!!!"
	"specular := GLFloatRGBA new.
	specular r: 1; g: 1;b: 1; a:1. 
	shinines:= GLFloatRGBA new.
	shinines r: 500. 	
	l_pos := GLFloatVector new.
	l_pos x: 0 ;y: 0;z: 0. 
	l_color := GLFloatRGBA new.
	l_color r: 1; g: 1;b: 1; a:1. 			
	lmodel_ambient := GLFloatRGBA new.
	lmodel_ambient r: 1;g: 1 ;b: 1; a:1."
	
	"fog_color := GLFloatRGBA new.
	fog_color r: 0.5; g: 0.5;b: 0.5; a:1. "
	
	gl := display gl.
	gl 		
		enable: GL_MULTISAMPLE ;		
		enable: GL_POLYGON_SMOOTH;
		enable: GL_NORMALIZE;
		clearDepth: 1; 
	 	enable: GL_DEPTH_TEST;
		shadeModel: GL_SMOOTH;	
		hint_target: GL_LINE_SMOOTH_HINT mode: GL_FASTEST;
		hint_target: GL_POLYGON_SMOOTH_HINT mode: GL_FASTEST;
		hint_target: GL_PERSPECTIVE_CORRECTION_HINT mode: GL_NICEST;
		
		"FOG"
		"enable: GL_FOG;
		fogi_pname: GL_FOG_MODE param: GL_EXP2;
		fogfv_pname: GL_FOG_COLOR params: fog_color;
		fogf_pname: GL_FOG_DENSITY param: 0.01;
		hint_target: GL_FOG_HINT mode: GL_DONT_CARE;
		fogf_pname: GL_FOG_START param: 1.0;
		fogf_pname: GL_FOG_END param: 5.0;"
		
		"LIGHT"
		"materialfv_face: GL_FRONT pname: GL_SPECULAR params: specular;
		materialfv_face: GL_FRONT pname: GL_SHININESS  params: shinines;
		lightfv_light: GL_LIGHT0 pname: GL_POSITION params: l_pos;
		lightfv_light: GL_LIGHT0 pname: GL_DIFFUSE params: l_color;
		lightfv_light: GL_LIGHT0 pname: GL_SPECULAR params: l_color;
		lightModelfv_pname: GL_LIGHT_MODEL_AMBIENT params: lmodel_ambient;
		enable: GL_LIGHTING;
		enable: GL_LIGHT0;	"
				
		depthFunc: GL_LEQUAL;
		depthMask: true.			
	gl 
		clearColor_red: configuration glBackground red green:  configuration glBackground green blue:  configuration glBackground blue alpha: 0;
		clear: GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT.
	gl 
		matrixMode: GL_PROJECTION; 						
		loadIdentity.	
			
	self perspectiveFovY: 100.0 
			aspect: (self width /self height) asFloat 
			zNear:  0.1 zFar: 10000.0.

	gl matrixMode: GL_MODELVIEW. 						
	gl loadIdentity.	
		
	self applyCamera.
	self drawCity: model.
	gl flush.! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 5/4/2012 11:41'!
rotateDown

	configuration cameraXPos: (configuration cameraXPos+ 3).
"	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. "
	! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 5/4/2012 11:41'!
rotateLeft

	configuration cameraYPos: (configuration cameraYPos+ 3).
	"display gl rotatef_angle: xrot x: 1 y: 0  z: 0."! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 5/4/2012 11:41'!
rotateRight
	
	configuration cameraYPos: (configuration cameraYPos - 3).
	"display gl rotatef_angle: xrot x: 1 y: 0  z: 0. "! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 5/4/2012 11:40'!
rotateTop
	configuration cameraXPos: (configuration cameraXPos - 3).
	"display gl rotatef_angle: yrot x: 0 y: 1  z: 0. "! !

!GLCity methodsFor: 'stepping and presenter' stamp: 'DouailleErwan 4/23/2012 10:46'!
step
	self changed! !

!GLCity methodsFor: 'testing' stamp: 'DouailleErwan 4/23/2012 10:46'!
stepTime
	^5! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 5/4/2012 11:39'!
translateBackward

	ztran := ztran - 3.
"	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. "
	! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 5/4/2012 11:39'!
translateDown

	ytran := ytran + 3.
"	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. "
	! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 5/4/2012 11:39'!
translateForward

	ztran := ztran + 3.
"	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. "
	! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 5/4/2012 11:39'!
translateLeft

	xtran := xtran - 3.
"	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. "
	! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 5/4/2012 11:39'!
translateRight

	xtran := xtran + 3.
"	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. "
	! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 5/4/2012 11:39'!
translateTop

	ytran := ytran - 3.
"	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. "
	! !

!GLCity methodsFor: 'drawing' stamp: 'douaille 4/7/2012 16:42'!
vertex: array texCoord: t

	display gl 
		texCoord2d_s:  t first t:  t second;
		vertex3d_x: array first y: array second  z: array third! !

GLViewportMorph subclass: #GLTest
	instanceVariableNames: 'rot model face top down grass xtran ytran ztran xrot yrot zrot znumb xnumb ynumb'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!GLTest commentStamp: '<historical>' prior: 0!
Doing some examples in OpenGL.!

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:08'!
applyCamera
	display gl translatef_x: xtran y: ytran z: ztran. 
	display gl  rotatef_angle: xrot x: 1 y: 0  z: 0. 
	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. 
	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. 
! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/11/2012 17:06'!
captureMouseDown: e
	|hits selectBuf viewport gl x y  size |
	 x := (e position x) - self position x.
	 y := (e position y) - self position y.
	selectBuf := ByteArray new: 8 * 512.
	hits := ByteArray new: 4 * 1.
	viewport := ByteArray new: 4 * 4.
	
	Transcript cr;show:'Position souris :', x asString, ' - ', y asString.
	
	gl := display gl.
	gl getIntegerv_pname: GL_VIEWPORT  params: viewport.
	gl selectBuffer_size: 512 buffer: selectBuf.
	gl renderMode: GL_SELECT.
	gl initNames.
	gl pushName: 0.
	gl matrixMode: GL_PROJECTION.
	gl pushMatrix.		
	gl loadIdentity.
	self myGluPickMatrix_x: x y: ((viewport nbLongAt: 1+12)-y) deltax: 5 deltay: 5 viewport: viewport. 
	gl ortho_left: 0 right: 3 bottom: 0 top: 3 zNear: -1 zFar: 1. 
	
	self cube_x: 1 y: 1 z: 1.
	
	gl matrixMode: GL_PROJECTION.
	gl popMatrix.
	gl flush.
	hits := (gl renderMode: GL_RENDER).
	Transcript cr;show: hits.
	
! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:08'!
city_x: x y: y z: z
	|gl|
	
	gl := display gl.

	gl enable: GL_TEXTURE_2D.
	gl bindTexture_target: GL_TEXTURE_2D texture: grass. 	
		
	gl begin: GL_QUADS;
		
		color3f_red: 1 green: 1 blue: 1; 
		vertex3f_x: -1 y: y  z: -1; 
		texCoord2d_s: 0 t: 0; 
		vertex3f_x: x y:  y z: -1; 
		texCoord2d_s: 0 t: 1; 
		vertex3f_x: x y:  y z: z; 
		texCoord2d_s: 1 t: 1; 
		vertex3f_x: -1 y:  y z: z; 
		texCoord2d_s: 1 t: 0; 
		
		vertex3f_x: -1 y:  y  z: -1; 
		texCoord2d_s: 0 t: 0; 
		vertex3f_x: -1 y:  y z: z; 
		texCoord2d_s: 0 t: 1; 
		vertex3f_x: x y:  y  z: z; 
		texCoord2d_s: 1 t: 1; 
		vertex3f_x: x y:  y z: -1; 
		texCoord2d_s: 1 t: 0; 

	end.
	! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/11/2012 10:12'!
cube_x: x y: y z: z
	|gl|
	
	gl := display gl.
	gl begin: GL_QUADS;
		pushMatrix;
		pushName: x;
		color3f_red: 0 green: 0 blue: 1; 
		vertex3f_x: x y: 0  z: z; 
		vertex3f_x: x  y: y z: z; 
		vertex3f_x: x+1 y: y z: z; 
		vertex3f_x: x+1 y: 0 z: z; 
		
		color3f_red: 0 green: 1 blue: 0; 
		vertex3f_x: x y: 0  z: z+1; 
		vertex3f_x: x+1 y:0  z: z+1; 
		vertex3f_x: x+1 y: y z: z+1; 
		vertex3f_x: x y: y z: z+1; 
		
		color3f_red: 1 green: 0 blue: 0;
		vertex3f_x: x+1 y: 0  z: z; 
		vertex3f_x: x+1  y: y z: z; 
		vertex3f_x: x+1 y: y  z: z+1; 
		vertex3f_x: x+1 y: 0  z: z+1; 
		
		color3f_red: 1 green: 0 blue: 1; 
		vertex3f_x: x y: 0 z: z+1; 
		vertex3f_x: x y: y z: z+1; 
		vertex3f_x: x y: y  z: z; 
		vertex3f_x: x y: 0 z:z; 
		
		color3f_red: 0 green: 1 blue: 1; 
		vertex3f_x: x y: 0  z:z; 
		vertex3f_x: x+1 y: 0 z: z; 
		vertex3f_x: x+1 y: 0 z: z+1; 
		vertex3f_x: x y: 0 z: z+1; 
		
		color3f_red: 1 green: 1 blue: 0; 
		vertex3f_x: x y: y  z: z; 
		vertex3f_x: x y: y z: z+1; 
		vertex3f_x: x+1 y: y  z: z+1; 
		vertex3f_x: x+1 y: y z: z; 
		popName;
		popMatrix;

	end.
	! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/9/2012 12:38'!
initialize
	
	super initialize.
	xrot := 0.
	yrot := 0.
	zrot := 0.
	xtran := 0.
	ytran := 0.
	ztran := -50.
	znumb := 0.
	xnumb := 0.
	ynumb := 0.
	rot := 0.
	
	self on: #mouseDown send: #captureMouseDown: to: self.! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:08'!
line_x: x y: y z: z
	|gl|
	
	gl := display gl.
	
	gl begin: GL_LINES;

		color3f_red: 1 green: 0 blue: 0; 
		vertex3f_x: x y: y  z: z; 
		vertex3f_x: x+1 y: y  z: z; 

		color3f_red: 0 green: 1 blue: 0; 
		vertex3f_x: x y: y z: z; 
		vertex3f_x: x y: y+1 z: z;
		 
		color3f_red: 0 green: 0 blue: 1; 
		vertex3f_x: x y:  y z: z; 
		vertex3f_x: x y: y z: z+1;
		
	end.
	! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/11/2012 15:42'!
myGluPickMatrix_x: x y: y deltax: deltax deltay: deltay viewport: viewport
	| floatStruct gl |
	Transcript cr;show: x asString,' - ', y asString,' - ', deltax asString,' - ', deltay asString.
	gl := display gl.
	floatStruct := GLFloatVector new.
	
	(deltax = 0 | deltay = 0)
	ifTrue: [^self].
	
	floatStruct x: (((viewport nbLongAt: 1+8) - 2 * ( x - (viewport nbLongAt: 1) )) / deltax) ;y:(((viewport nbLongAt: 1+12)  - 2 * (y - (viewport nbLongAt: 1+4) )) / deltay); z: 0.
	gl translatef_x:floatStruct x y: floatStruct y z: floatStruct z.
	
	floatStruct x: ((viewport nbLongAt: 1+8) / deltax) asFloat;y: ((viewport nbLongAt: 1+12) / deltay) asFloat ;z: 1 asFloat.
	gl scalef_x:floatStruct x y: floatStruct y z: floatStruct z.
! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:08'!
openInWorld

	super openInWorld.
	
	self startStepping.! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:08'!
perspectiveFovY: fovY aspect: aspect zNear: zNear zFar: zFar
"Replaces gluPerspective. Sets the frustum to perspective mode.
// fovY     - Field of vision in degrees in the y direction
// aspect   - Aspect ratio of the viewport
// zNear    - The near clipping distance
// zFar     - The far clipping distance
 "
	| fW fH |
	fH := (fovY / (360 * Float pi)) tan * zNear.
	"fH = tan( fovY / 360 * pi ) * zNear;"
	fW := fH * aspect.
	display gl frustum_left: fW negated  right:  fW bottom: fH negated top: fH  zNear:  zNear zFar:   zFar! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/11/2012 10:20'!
render

	| gl |
	self checkSession.
	gl := display gl.
	gl 
		enable: GL_MULTISAMPLE ;
		shadeModel: GL_SMOOTH;					
		clearDepth: 1; 
	 	enable: GL_DEPTH_TEST;
		depthFunc: GL_LEQUAL;
		depthMask: true.								

	gl 
		clearColor_red: 1 green:  1 blue:  1 alpha: 0;
		clear: GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT.

	
	gl matrixMode: GL_PROJECTION; 						
		loadIdentity.	
			
	self perspectiveFovY: 45.0 
			aspect: (self width /self height) asFloat 
			zNear:  0.1 zFar: 010000.0.

	gl matrixMode: GL_MODELVIEW. 						
	gl loadIdentity.	


	self applyCamera.
	gl rotatef_angle: (rot\\360) x: 1 y: 1 z: 1.
	self line_x: 0 y: 0 z: 0.
	self cube_x: 1 y: 1 z: 1.
	gl flush! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:08'!
step
	rot := rot + 2.
	self changed! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/9/2012 12:34'!
stepTime
	^ 1! !

Object subclass: #AbstractCityComponent
	instanceVariableNames: 'model widthSelector heightSelector width height'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Core'!

!AbstractCityComponent commentStamp: '<historical>' prior: 0!
I'm an abstract class root of the city elements!

!AbstractCityComponent methodsFor: 'accessing' stamp: 'StephaneDucasse 5/14/2012 10:27'!
height
	^height! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'StephaneDucasse 5/14/2012 10:27'!
height: anObject
	height := anObject.! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:29'!
heightSelector
	^heightSelector! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:28'!
heightSelector: anObject
	heightSelector := anObject.! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'StephaneDucasse 5/14/2012 12:41'!
initialize
	width := 0.5.
	height := 0.5.! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 4/2/2012 14:10'!
model 
	"Returns the model associated with the receiver, it can be a class, package...."
	
	^model! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 4/2/2012 14:10'!
model: aModel
	"Set the model associated with the receiver, it can be a class, package...."
	
	model := aModel! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'StephaneDucasse 5/14/2012 10:26'!
width
	^width! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'StephaneDucasse 5/14/2012 10:26'!
width: anObject
	width := anObject.! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:28'!
widthSelector
	^widthSelector! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:28'!
widthSelector: anObject
	widthSelector := anObject.! !

AbstractCityComponent subclass: #Building
	instanceVariableNames: 'district'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Core'!

!Building commentStamp: '<historical>' prior: 0!
A Building is the level abstraction.!

!Building class methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 5/14/2012 11:16'!
forClass: aClassName inDistrict: aDistrict widthSelector: aWidthSelector heightSelector: aHeightSelector.

	^ self new 
		model: aClassName
		inDistrict: aDistrict
		widthSelector: aWidthSelector 
		heightSelector: aHeightSelector.
		! !

!Building methodsFor: 'accessing' stamp: 'StephaneDucasse 5/14/2012 13:30'!
district
	^district ! !

!Building methodsFor: 'accessing' stamp: 'StephaneDucasse 5/14/2012 13:30'!
district: aDistrict
	district := aDistrict.! !

!Building methodsFor: 'accessing' stamp: 'StephaneDucasse 5/14/2012 15:29'!
height
	(super height < 0.5)
	ifTrue: [^ 0.5].
	^ super height.! !

!Building methodsFor: 'accessing' stamp: 'StephaneDucasse 5/14/2012 15:27'!
heightSelector: anObject
	super heightSelector: anObject.
	(self heightSelector asString = 'none')
	ifTrue: [
		self height: (((1 + self model selectors size)) ).
		] 
	ifFalse: [
		self height: (((1 + self model selectors size) perform: (self heightSelector))*2).
		].! !

!Building methodsFor: 'accessing' stamp: 'StephaneDucasse 5/14/2012 13:30'!
model: aModel inDistrict: aDistrict widthSelector: aWidthSelector heightSelector: aHeightSelector.

	model := aModel.
	district := aDistrict.
	self widthSelector: aWidthSelector.
	self heightSelector: aHeightSelector.
	aDistrict add: self.
! !

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 5/15/2012 10:19'!
printOn: aStream

	district ifNotNil: [ aStream
					nextPutAll: district asString; 
					nextPutAll: ' -> '].
					
	model ifNotNil: [ aStream 
					nextPutAll: ' Buidling Name : '; 
					nextPutAll: model name].! !

!Building methodsFor: 'accessing' stamp: 'StephaneDucasse 5/14/2012 15:30'!
width
	(super width < 0.5)
	ifTrue: [^ 0.5].
	^ super width.! !

!Building methodsFor: 'accessing' stamp: 'StephaneDucasse 5/14/2012 15:24'!
widthSelector: anObject
	super widthSelector: anObject.
	(self widthSelector asString = 'none')
	ifTrue: [
		self width: (((1 + self model allInstVarNames size))).
		] 
	ifFalse: [
		self width: (((1 + self model allInstVarNames size) perform: (self widthSelector))*2).
		].
	! !

AbstractCityComponent subclass: #City
	instanceVariableNames: 'districts name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Core'!

!City commentStamp: '<historical>' prior: 0!
A City represents the largest model element. It contains a list of districts.!

!City class methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 5/14/2012 11:05'!
model: aName
	^ self new 
		model: aName;
		name: aName
		! !

!City methodsFor: 'adding' stamp: 'DouailleErwan 5/14/2012 16:31'!
add: aDistrict

	districts add: aDistrict.
	self width: (districts inject: 0 into: [ :sum :each | sum + each width.]).
	^ aDistrict! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 5/14/2012 16:40'!
defaultCityWidth: size
	^ (size)sqrt*20
						! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 4/2/2012 14:36'!
districts

	^ districts! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 4/3/2012 14:51'!
districts: anObject
	districts := anObject! !

!City methodsFor: 'testing' stamp: 'StephaneDucasse 5/14/2012 09:36'!
hasDistrictNamed: aString
	
	^ districts anySatisfy: [ :each | each model name = aString ]! !

!City methodsFor: 'initialize-release' stamp: 'StephaneDucasse 5/14/2012 09:36'!
initialize

	super initialize.
	districts := OrderedCollection new.! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 4/2/2012 14:38'!
name
	^ name! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 4/2/2012 14:38'!
name: anObject
	name := anObject! !

!City methodsFor: 'testing' stamp: 'douaille 4/10/2012 09:37'!
printOn: aStream

	model ifNotNil: [ aStream 
					nextPutAll: ' City name : '; 
					nextPutAll: self name].! !

!City methodsFor: 'accessing' stamp: 'StephaneDucasse 5/14/2012 13:21'!
width: anObject
	width := (self defaultCityWidth: anObject).! !

AbstractCityComponent subclass: #District
	instanceVariableNames: 'buildings city'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Core'!

!District commentStamp: '<historical>' prior: 0!
A District is a secondary city abstractions!

!District class methodsFor: 'instance creation' stamp: 'StephaneDucasse 5/14/2012 10:41'!
forPackage: aPackage inCity: aCity

	^ self new 
		model: aPackage
		inCity: aCity
		! !

!District methodsFor: 'printing' stamp: 'StephaneDucasse 5/14/2012 13:07'!
add: aBuilding

	buildings add: aBuilding.
	self width: (buildings inject: 0 into: [:sum :each | sum + each width.]).
	^ aBuilding.! !

!District methodsFor: 'configuration' stamp: 'DouailleErwan 4/3/2012 14:15'!
buildings
	^buildings! !

!District methodsFor: 'accessing' stamp: 'StephaneDucasse 5/14/2012 13:30'!
city
	^city.! !

!District methodsFor: 'accessing' stamp: 'StephaneDucasse 5/14/2012 13:31'!
city: aCity
	city :=  aCity! !

!District methodsFor: 'accessing' stamp: 'StephaneDucasse 5/14/2012 13:25'!
defaultDistrictWidth: size
	^ size sqrt asFloat roundedUp*2 
		! !

!District methodsFor: 'configuration' stamp: 'StephaneDucasse 5/14/2012 09:37'!
initialize 
	
	super initialize.
	buildings := OrderedCollection new.! !

!District methodsFor: 'private' stamp: 'StephaneDucasse 5/14/2012 13:31'!
model: aModel inCity: aCity

	model := aModel.
	city := aCity.
	aCity add: self.! !

!District methodsFor: 'printing' stamp: 'DouailleErwan 5/15/2012 10:21'!
printOn: aStream

	city ifNotNil: [ aStream
					nextPutAll: city asString;
					nextPutAll: '-> '].
					
	model ifNotNil: [ aStream 
					nextPutAll: ' District Name : '; 
					nextPutAll: model name ].! !

!District methodsFor: 'private' stamp: 'StephaneDucasse 5/14/2012 11:35'!
width: anObject
	width := self defaultDistrictWidth: anObject.! !

Object subclass: #CityConfiguration
	instanceVariableNames: 'buildingGap buildingHighColor buildingLowColor buildingMaxHeightColor buildingMediumHeightColor buildingMaxWidthColor cameraXPos cameraYPos cameraZPos cityColor districtColor districtGap glBackground openGL model buildingMediumColor buildingWidthCalcList buildingHeightCalcList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Core'!

!CityConfiguration commentStamp: '<historical>' prior: 0!
Provides default configuration parameters for Source city GL views. All the default methods provide extension poinits for customizing GL views. If someone wants to describe their own config, default methods can be overriden.!

!CityConfiguration class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/10/2012 11:37'!
default
	^ CityImporter new defaultModel.! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
buildingGap
	^ buildingGap! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
buildingGap: anObject
	buildingGap := anObject! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 5/4/2012 12:22'!
buildingHeightCalcList
	^ buildingHeightCalcList! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 5/4/2012 12:22'!
buildingHeightCalcList: anObject
	buildingHeightCalcList := anObject! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
buildingHighColor
	^ buildingHighColor! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
buildingHighColor: anObject
	buildingHighColor := anObject! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
buildingLowColor
	^ buildingLowColor! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
buildingLowColor: anObject
	buildingLowColor := anObject! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
buildingMaxHeightColor
	^ buildingMaxHeightColor! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
buildingMaxHeightColor: anObject
	buildingMaxHeightColor := anObject! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
buildingMaxWidthColor
	^ buildingMaxWidthColor! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
buildingMaxWidthColor: anObject
	buildingMaxWidthColor := anObject! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/26/2012 10:47'!
buildingMediumColor
	^ buildingMediumColor! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/26/2012 10:47'!
buildingMediumColor: anObject
	buildingMediumColor := anObject! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/26/2012 10:22'!
buildingMediumHeightColor
	^ buildingMediumHeightColor! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/26/2012 10:22'!
buildingMediumHeightColor: anObject
	buildingMediumHeightColor := anObject! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 5/4/2012 12:22'!
buildingWidthCalcList
	^buildingWidthCalcList! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 5/4/2012 12:22'!
buildingWidthCalcList: anObject
	buildingWidthCalcList := anObject! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
cameraXPos
	^ cameraXPos! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
cameraXPos: anObject
	cameraXPos := anObject! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
cameraYPos
	^ cameraYPos! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
cameraYPos: anObject
	cameraYPos := anObject! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
cameraZPos
	^ cameraZPos! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
cameraZPos: anObject
	cameraZPos := anObject! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
cityColor
	^ cityColor! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
cityColor: anObject
	cityColor := anObject! !

!CityConfiguration methodsFor: 'defalt-values' stamp: 'DouailleErwan 4/27/2012 15:34'!
defaultBuildingGap
	^2! !

!CityConfiguration methodsFor: 'defalt-values' stamp: 'DouailleErwan 4/27/2012 15:35'!
defaultBuildingHighColor
	^Color red! !

!CityConfiguration methodsFor: 'defalt-values' stamp: 'DouailleErwan 4/27/2012 15:35'!
defaultBuildingLowColor
	^ Color blue! !

!CityConfiguration methodsFor: 'defalt-values' stamp: 'DouailleErwan 4/27/2012 15:35'!
defaultBuildingMaxHeightColor
	^10! !

!CityConfiguration methodsFor: 'defalt-values' stamp: 'DouailleErwan 4/27/2012 15:35'!
defaultBuildingMaxWidthColor
	^5! !

!CityConfiguration methodsFor: 'defalt-values' stamp: 'DouailleErwan 4/27/2012 15:35'!
defaultBuildingMediumColor
	^ 5! !

!CityConfiguration methodsFor: 'defalt-values' stamp: 'DouailleErwan 4/27/2012 15:36'!
defaultBuildingMediumHeightColor
	^5! !

!CityConfiguration methodsFor: 'defalt-values' stamp: 'DouailleErwan 4/27/2012 15:36'!
defaultCameraXPos
 	^-196! !

!CityConfiguration methodsFor: 'defalt-values' stamp: 'DouailleErwan 4/27/2012 15:36'!
defaultCameraYPos
	^ -15! !

!CityConfiguration methodsFor: 'defalt-values' stamp: 'DouailleErwan 4/27/2012 15:36'!
defaultCameraZPos
	^0! !

!CityConfiguration methodsFor: 'defalt-values' stamp: 'DouailleErwan 4/27/2012 15:37'!
defaultCityColor
	^Color green! !

!CityConfiguration methodsFor: 'defalt-values' stamp: 'DouailleErwan 4/27/2012 15:37'!
defaultDistrictColor
	^Color yellow! !

!CityConfiguration methodsFor: 'defalt-values' stamp: 'DouailleErwan 4/27/2012 15:37'!
defaultDistrictGap
	^2! !

!CityConfiguration methodsFor: 'defalt-values' stamp: 'DouailleErwan 4/27/2012 15:37'!
defaultGlBackground
	^Color white! !

!CityConfiguration methodsFor: 'defalt-values' stamp: 'DouailleErwan 4/27/2012 15:43'!
defaultOpenGL! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
districtColor
	^ districtColor! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
districtColor: anObject
	districtColor := anObject! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
districtGap
	^ districtGap! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
districtGap: anObject
	districtGap := anObject! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 5/11/2012 16:20'!
glAAList
	^ glAAList! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 5/11/2012 16:20'!
glAAList: anObject
	glAAList := anObject! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
glBackground
	^ glBackground! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
glBackground: anObject
	glBackground := anObject! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 5/11/2012 16:20'!
glPerspectiveList
	^ glPerspectiveList! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 5/11/2012 16:20'!
glPerspectiveList: anObject
	glPerspectiveList := anObject! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 16:33'!
model
	^ model! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 16:33'!
model: anObject
	model := anObject! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
openGL
	^ openGL! !

!CityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:14'!
openGL: anObject
	openGL := anObject! !

Object subclass: #CityImporter
	instanceVariableNames: 'city districts buildings widthSelector heightSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Importer'!

!CityImporter commentStamp: '<historical>' prior: 0!
I'm responsible for populating a city from a model (usually a ring model)!

!CityImporter class methodsFor: 'default-model' stamp: 'StephaneDucasse 5/14/2012 11:44'!
defaultModel
	
	^ self new 
	cityNamed: 'CodCT' withPackageNames: RPackageOrganizer default packageNames.! !

!CityImporter methodsFor: 'import' stamp: 'StephaneDucasse 5/14/2012 11:44'!
basicBuilding: aClassName district: aDistrict

	^ Building forClass: aClassName inDistrict: aDistrict widthSelector: self widthSelector heightSelector: self heightSelector.! !

!CityImporter methodsFor: 'import' stamp: 'StephaneDucasse 5/14/2012 11:44'!
basicDistrict: aPackageName city: aCity
	
	^  District forPackage: (self packageNamed: aPackageName) inCity: aCity.
	
	! !

!CityImporter methodsFor: 'accessing' stamp: 'StephaneDucasse 5/14/2012 11:44'!
city
	^city! !

!CityImporter methodsFor: 'accessing' stamp: 'StephaneDucasse 5/14/2012 11:44'!
city: aCity
	city := aCity! !

!CityImporter methodsFor: 'import' stamp: 'StephaneDucasse 5/14/2012 11:44'!
cityNamed: aName withPackageNames: aCol

	self cityNamed: aName withPackageNames: aCol widthSelectorChoice: #yourself heightSelectorChoice: #yourself.! !

!CityImporter methodsFor: 'import' stamp: 'StephaneDucasse 5/14/2012 15:19'!
cityNamed: aName withPackageNames: aCol widthSelectorChoice: aSelectorw heightSelectorChoice: aSelectorh

	| sW sH |
	self city: (City model: aName).
	self heightSelector: aSelectorh.
	self widthSelector: aSelectorw.
	aCol do: [:each | self importPackageAsDistrict: each ].
	self importClassAsBuilding .! !

!CityImporter methodsFor: 'import' stamp: 'StephaneDucasse 5/14/2012 11:44'!
ensureBuilding: aClassName district: aDistrict
	^ buildings
			at: aClassName 
			ifAbsentPut: [ self basicBuilding: aClassName district: aDistrict].
			
						! !

!CityImporter methodsFor: 'import' stamp: 'StephaneDucasse 5/14/2012 11:44'!
ensureDistrict: aPackageName
	^districts 
			at: aPackageName 
			ifAbsentPut: [ self basicDistrict: aPackageName city: (self city)].
			
						! !

!CityImporter methodsFor: 'accessing' stamp: 'StephaneDucasse 5/14/2012 11:44'!
heightSelector
	^ heightSelector! !

!CityImporter methodsFor: 'accessing' stamp: 'StephaneDucasse 5/14/2012 11:44'!
heightSelector: anObject
	heightSelector := anObject! !

!CityImporter methodsFor: 'import' stamp: 'StephaneDucasse 5/14/2012 11:44'!
importClassAsBuilding
	(self city districts) do: [ :each |
		(each model classes) do: [ :eachClass |
			eachClass isBehavior
				ifTrue: [ self importClassAsBuilding: eachClass district: each ]]
			displayingProgress: 'importing classes'.
		].! !

!CityImporter methodsFor: 'import' stamp: 'StephaneDucasse 5/14/2012 11:44'!
importClassAsBuilding: aClassName district: aDistrict
	
	self ensureBuilding: aClassName district: aDistrict.
	! !

!CityImporter methodsFor: 'import' stamp: 'StephaneDucasse 5/14/2012 11:44'!
importPackageAsDistrict: aPackageName
	
	self ensureDistrict: aPackageName.
	! !

!CityImporter methodsFor: 'initialize-release' stamp: 'StephaneDucasse 5/14/2012 11:44'!
initialize
	super initialize.
	districts := Dictionary new.
	buildings := Dictionary new.! !

!CityImporter methodsFor: 'utils' stamp: 'StephaneDucasse 5/14/2012 11:44'!
numberOfBuilding

	^ city districts inject: 0 into: [:sum :each | sum + each buildings size.].
! !

!CityImporter methodsFor: 'utils' stamp: 'StephaneDucasse 5/14/2012 11:44'!
numberOfDistrict
	^city districts size! !

!CityImporter methodsFor: 'utils' stamp: 'StephaneDucasse 5/14/2012 11:44'!
packageNamed: aString
	^ RPackageOrganizer default packageNamed: aString! !

!CityImporter methodsFor: 'accessing' stamp: 'StephaneDucasse 5/14/2012 14:18'!
widthSelector
	^ widthSelector! !

!CityImporter methodsFor: 'accessing' stamp: 'StephaneDucasse 5/14/2012 14:18'!
widthSelector: anObject
	widthSelector := anObject! !

Object subclass: #CityObject
	instanceVariableNames: 'model widthSelector heightSelector colorSelector historyArray historyChoice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!CityObject commentStamp: '<historical>' prior: 0!
I'm an abstract class root of the city elements!

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:29'!
colorSelector
	^colorSelector! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:29'!
colorSelector: anObject
	colorSelector := anObject.! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:29'!
heightSelector
	^heightSelector! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:28'!
heightSelector: anObject
	heightSelector := anObject.! !

!CityObject methodsFor: 'accessing' stamp: 'douaille 4/6/2012 11:48'!
historyArray
	^ historyArray! !

!CityObject methodsFor: 'accessing' stamp: 'douaille 4/6/2012 11:48'!
historyArray: anArray
	 historyArray := anArray! !

!CityObject methodsFor: 'accessing' stamp: 'douaille 4/6/2012 11:49'!
historyChoice
	 ^historyChoice! !

!CityObject methodsFor: 'accessing' stamp: 'douaille 4/6/2012 11:49'!
historyChoice: selectedHistory
	 historyChoice := selectedHistory! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:38'!
initialize
	
	self widthSelector: #0.
	self colorSelector: #0.
	self heightSelector: #0.! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/2/2012 14:10'!
model 
	"Returns the model associated with the receiver, it can be a class, package...."
	
	^model! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/2/2012 14:10'!
model: aModel
	"Set the model associated with the receiver, it can be a class, package...."
	
	model := aModel! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:28'!
widthSelector
	^widthSelector! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:28'!
widthSelector: anObject
	widthSelector := anObject.! !

Object subclass: #CityVisualization
	instanceVariableNames: 'buildingGap buildingHighColor buildingLowColor buildingMaxHeightColor buildingMaxWidthColor cameraXPos cameraYPos cameraZPos cityColor districtColor districtGap glBackground listPackages openGL win model buildingMediumHeightColor buildingMediumColor glCity configurationClass unselectedSelectionList unselectedItems unselectedSelectionIndex selectedSelectionList selectedItems selectedSelectionIndex buildingHeightCalcList buildingWidthCalcList glAAList glPerspectiveList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Tools'!

!CityVisualization commentStamp: '<historical>' prior: 0!
A CityVisualization is the class who you use to configure the parameters of your draw 3D visualization, pakcage which you enter.!

!CityVisualization methodsFor: 'action-List' stamp: 'DouailleErwan 5/3/2012 11:14'!
addAllButtonAction
	self addAllItems.! !

!CityVisualization methodsFor: 'action-List' stamp: 'DouailleErwan 5/3/2012 10:39'!
addAllButtonState
	^false! !

!CityVisualization methodsFor: 'action-List' stamp: 'DouailleErwan 5/7/2012 10:40'!
addAllItems
	self selectedItems addAll: self unselectedItems.
	self unselectedItems removeAll.
	unselectedSelectionList removeAll.
	self unselectedSelectionIndex: 0.
	self
		changed: #selectedItems;
		changed: #hasSelectedItems;
		changed: #hasSelectedSelections;
		changed: #unselectedItems;
		changed: #hasUnselectedItems.! !

!CityVisualization methodsFor: 'action-List' stamp: 'DouailleErwan 5/3/2012 11:14'!
addButtonAction
	self addSelectedItems.! !

!CityVisualization methodsFor: 'action-List' stamp: 'DouailleErwan 5/3/2012 10:53'!
addButtonState
	^false! !

!CityVisualization methodsFor: 'action-List' stamp: 'DouailleErwan 5/7/2012 10:40'!
addSelectedItems

	self selectedItems addAll: self unselectedSelectionItems..
	self unselectedItems removeAll:  self unselectedSelectionItems..
	unselectedSelectionList removeAll.
	self selectedSelectionIndex: 0.
	self
		changed: #selectedItems;
		changed: #hasSelectedItems;
		changed: #hasSelectedSelections;
		changed: #unselectedItems;
		changed: #hasUnselectedItems.! !

!CityVisualization methodsFor: 'action-List' stamp: 'DouailleErwan 5/3/2012 10:38'!
buildAddAllButton
	^(win
		newButtonFor: self
		getState: #addAllButtonState
		action: #addAllButtonAction 
		arguments: nil
		getEnabled: #hasUnselectedItems
		label: '>>'
		help: nil)
		hResizing: #spaceFill! !

!CityVisualization methodsFor: 'action-List' stamp: 'DouailleErwan 5/3/2012 10:54'!
buildAddButton
	^(win
		newButtonFor: self
		getState: #addButtonState
		action: #addButtonAction 
		arguments: nil
		getEnabled: #hasUnselectedSelections
		label: '>'
		help: nil)
		hResizing: #spaceFill! !

!CityVisualization methodsFor: 'action-List' stamp: 'DouailleErwan 5/3/2012 11:09'!
buildRemoveAllButton
	^(win
		newButtonFor: self
		getState: #removeAllButtonState
		action: #removeAllButtonAction
		arguments: nil
		getEnabled: #hasSelectedItems
		label: '<<'
		help: nil)
		hResizing: #spaceFill! !

!CityVisualization methodsFor: 'action-List' stamp: 'DouailleErwan 5/3/2012 11:09'!
buildRemoveButton
	^(win
		newButtonFor: self
		getState: #removeButtonState
		action: #removeButtonAction 
		arguments: nil
		getEnabled: #hasSelectedSelections
		label: '<'
		help: nil)
		hResizing: #spaceFill! !

!CityVisualization methodsFor: 'selectedList' stamp: 'DouailleErwan 5/3/2012 11:13'!
buildSelectedItemsList
	^(PluggableListMorph
		on: self 
		list: #selectedItems
		primarySelection: #selectedSelectionIndex
		changePrimarySelection: #selectedSelectionIndex:
		listSelection: #selectedSelectionAt:
		changeListSelection: #selectedSelectionAt:put:
		menu: nil)
			hResizing: #spaceFill;
			vResizing: #spaceFill.! !

!CityVisualization methodsFor: 'unselectedList' stamp: 'DouailleErwan 5/3/2012 11:12'!
buildUnselectedItemsList
	^(PluggableListMorph
		on: self 
		list: #unselectedItems
		primarySelection: #unselectedSelectionIndex
		changePrimarySelection: #unselectedSelectionIndex:
		listSelection: #unselectedSelectionAt:
		changeListSelection: #unselectedSelectionAt:put:
		menu: nil)
			hResizing: #spaceFill;
			vResizing: #spaceFill.! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwans 5/2/2012 10:08'!
buildingGap
	^ buildingGap! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
buildingGap: anObject
	
	buildingGap := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/4/2012 10:59'!
buildingHeightCalcList
	^ buildingHeightCalcList! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/4/2012 10:59'!
buildingHeightCalcList: anObject
	buildingHeightCalcList := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
buildingHighColor
	
	^ buildingHighColor! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
buildingHighColor: anObject
	
	buildingHighColor := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
buildingLowColor
	
	^ buildingLowColor! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
buildingLowColor: anObject
	
	buildingLowColor := anObject! !

!CityVisualization methodsFor: 'action-CityConfiguration' stamp: 'StephaneDucasse 5/14/2012 15:27'!
buildingMaxHeightCalcColor: anObject
	((self buildingHeightCalcList selectedItem asSymbol) asString = 'none')
	ifTrue: [
		^ (anObject).
		] 
	ifFalse: [
		^ (anObject perform: (self buildingHeightCalcList selectedItem asSymbol))*2.
		].! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
buildingMaxHeightColor
	
	^ buildingMaxHeightColor! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/7/2012 12:50'!
buildingMaxHeightColor: anObject
		buildingMaxHeightColor := (anObject)! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
buildingMaxWidthColor
	
	^ buildingMaxWidthColor! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/7/2012 12:44'!
buildingMaxWidthColor: anObject
	buildingMaxWidthColor:= anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/26/2012 10:41'!
buildingMediumColor
	
	^ buildingMediumColor! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/7/2012 12:44'!
buildingMediumColor: anObject
	buildingMediumColor := anObject! !

!CityVisualization methodsFor: 'action-CityConfiguration' stamp: 'StephaneDucasse 5/14/2012 15:28'!
buildingMediumHeightCalcColor: anObject
	((self buildingHeightCalcList selectedItem asSymbol) asString = 'none')
	ifTrue: [
		^ (anObject).
		] 
	ifFalse: [
		^ (anObject perform: (self buildingHeightCalcList selectedItem asSymbol))*2.
		].! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/26/2012 10:40'!
buildingMediumHeightColor
	
	^ buildingMediumHeightColor! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/7/2012 12:50'!
buildingMediumHeightColor: anObject
		buildingMediumHeightColor := (anObject).
	! !

!CityVisualization methodsFor: 'displaying' stamp: 'DouailleErwan 5/7/2012 12:32'!
buildingTab
		^(win newRow:{
				win newGroupbox: 'Color settings' forAll:{
					(win newTitle: 'Low color' for: (((buildingLowColor) minHeight: 80; minWidth: 120))).
					(win newTitle: 'Medium color' for: (((buildingMediumColor) minHeight: 80; minWidth: 120))).
					(win newTitle: 'High color' for: ((buildingHighColor) minHeight: 80; minWidth: 120))
					}.
				win newGroupbox: 'Value settings' forAll:{
					(win newTitle: 'Gap between each building' for: (
						(win newTextEntryFor:  (buildingGap)
							getText: #contents 
							setText:  #contents:
							help: 'insert an Integer'))).
					(win newTitle: 'Medium selector size by building' for: (
						(win newTextEntryFor:  (buildingMediumHeightColor)
							getText: #contents 
							setText:  #contents:
							help: 'insert an Integer'))).
					(win newTitle: 'Max selector size by building' for: (
						(win newTextEntryFor:  (buildingMaxHeightColor)
							getText: #contents 
							setText:  #contents:
							help: 'insert an Integer'))).
				}.
				win newGroupbox: 'Size settings' forAll:{
					(win newTitle: 'Building height calculator' for: (
						(win newDropListFor: (buildingHeightCalcList)
							list: #list 
							getSelected: #selectionIndex 
							setSelected: #selectionIndex: 
							help: 'Method of calcul for better visualization'))).
					(win newTitle: 'Building width calculator' for: (
						(win newDropListFor: (buildingWidthCalcList)
							list: #list 
							getSelected: #selectionIndex 
							setSelected: #selectionIndex: 
							help: 'Method of calcul for better visualization'))).
				}.
			})! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/4/2012 10:59'!
buildingWidthCalcList
	^ buildingWidthCalcList! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/4/2012 10:59'!
buildingWidthCalcList: anObject
	buildingWidthCalcList := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
cameraXPos
	
	^ cameraXPos! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
cameraXPos: anObject
	
	cameraXPos := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
cameraYPos
	
	^ cameraYPos! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
cameraYPos: anObject
	
	cameraYPos := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
cameraZPos
	
	^ cameraZPos! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
cameraZPos: anObject
	
	cameraZPos := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
cityColor
	
	^ cityColor! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
cityColor: anObject
	
	cityColor := anObject! !

!CityVisualization methodsFor: 'action-CityConfiguration' stamp: 'StephaneDucasse 5/14/2012 14:00'!
cityConfigurationBuild
	|config tmp |
	tmp := CityImporter new.
	tmp cityNamed: 'CodCT' withPackageNames: (self selectedItems) widthSelectorChoice: (self buildingWidthCalcList selectedItem asSymbol) heightSelectorChoice: (self buildingHeightCalcList selectedItem asSymbol).
	self model: tmp.
	config := CityConfiguration new.
	^config cityColor: self cityColor selectedColor;
		districtColor: self districtColor selectedColor;
		districtGap: self districtGap contents asInteger;
		buildingLowColor: self buildingLowColor selectedColor;
		buildingMediumColor: self buildingMediumColor selectedColor;	
		buildingHighColor: self buildingHighColor selectedColor;	
		buildingGap: self buildingGap contents asInteger;
		buildingMediumHeightColor: (self buildingMediumHeightCalcColor: (self buildingMediumHeightColor contents asInteger));
		buildingMaxHeightColor: (self buildingMaxHeightCalcColor: (self buildingMaxHeightColor contents asInteger));
		buildingMaxWidthColor: self buildingMaxWidthColor contents asInteger;
		buildingHeightCalcList: self buildingHeightCalcList selectedItem asString;
		buildingWidthCalcList: self buildingWidthCalcList selectedItem asString;
		glBackground: self glBackground selectedColor ;
		glAAList: self glAAList selectedItem asString;
		glPerspectiveList: self glPerspectiveList selectedItem asString;
		cameraXPos: self cameraXPos contents asInteger;
		cameraYPos: self cameraYPos contents asInteger;
		cameraZPos: self cameraZPos contents asInteger;
		model: self model.! !

!CityVisualization methodsFor: 'displaying' stamp: 'DouailleErwan 5/4/2012 10:07'!
cityTab
		^(win newTitle: 'City color' for: (
				(cityColor) minHeight: 80; minWidth: 120;vResizing: #spaceFill))! !

!CityVisualization methodsFor: 'displaying' stamp: 'DouailleErwan 5/3/2012 09:52'!
components
	^(win newTabGroup: {
			(win newRow: {
				win newImage: PharoTheme newDefault smallConfigurationIcon . 
				win newLabel: 'Importer configuration'	})->
				(win newGroupbox: 'Select packages to visualize' forAll: { self packageTab}).
				'City settings'->(self cityTab).
				'Districts settings'->(self districtTab).
				'Buildings settings'->(self buildingTab).
				'OpenGL view settings'->(self openGLTab).
				})
			! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/27/2012 16:08'!
configurationClass

	^ CityConfiguration! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/11/2012 16:23'!
configurationClass1
	^ configurationClass! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/27/2012 14:51'!
configurationClass: aClass

	configurationClass := aClass! !

!CityVisualization methodsFor: 'displaying' stamp: 'DouailleErwan 4/27/2012 16:00'!
display
	|dock container |
		dock := win newToolDockingBar.
		dock
			addMorph: self toolbar.
			
		container := PanelMorph new.
		container 
			changeTableLayout; 
			listDirection: #rigthToLeft.
		container addMorph: self components.
		win
			addMorph: dock
			fullFrame: (LayoutFrame fractions: (0@0 corner: 1@0) offsets: (0@0 corner: 0 @ dock minExtent y));
			addMorph: container
			fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1) offsets: (0@dock minExtent y corner: 0 @ 0)).
		win
			themeChanged;
			title: 'SourceCity Configuration';
			openInWorld;
			width: 700;
			height: 500.! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
districtColor
	
	^ districtColor! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
districtColor: anObject
	
	districtColor := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
districtGap
	
	^ districtGap! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
districtGap: anObject
	
	districtGap := anObject! !

!CityVisualization methodsFor: 'displaying' stamp: 'DouailleErwans 5/2/2012 10:14'!
districtTab
		^(win newRow:{
				win newGroupbox: 'Color settings' forAll:{
						(win newTitle: 'District color' for: ((districtColor) minHeight: 80; minWidth: 120)).
					}.
				win newGroupbox: 'Size settings' forAll:{
						(win newTitle: 'Gap between each district' for: (
							(win newTextEntryFor:  (districtGap)
								getText: #contents 
								setText:  #contents:
								help: 'insert an Integer'))).
					}
				})! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/11/2012 16:23'!
glAAList
	^ glAAList! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/11/2012 16:23'!
glAAList: anObject
	glAAList := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
glBackground
	
	^ glBackground! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
glBackground: anObject
	
	glBackground := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/11/2012 16:23'!
glCity
	^ glCity! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/11/2012 16:23'!
glCity: anObject
	glCity := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/11/2012 16:23'!
glPerspectiveList
	^ glPerspectiveList! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/11/2012 16:23'!
glPerspectiveList: anObject
	glPerspectiveList := anObject! !

!CityVisualization methodsFor: 'selectedList' stamp: 'DouailleErwan 5/3/2012 11:08'!
hasSelectedItems
	"Answer whether the selected list has items."

	^self selectedItems notEmpty! !

!CityVisualization methodsFor: 'selectedList' stamp: 'DouailleErwan 5/3/2012 11:08'!
hasSelectedSelections
	"Answer whether the selected list has selected items."

	^selectedSelectionList anySatisfy: [:selected | selected]! !

!CityVisualization methodsFor: 'unselectedList' stamp: 'DouailleErwan 5/3/2012 10:07'!
hasUnselectedItems
	^self unselectedItems notEmpty! !

!CityVisualization methodsFor: 'unselectedList' stamp: 'DouailleErwan 5/3/2012 10:11'!
hasUnselectedSelections
	"Answer whether the unselected list has selected items."

	^unselectedSelectionList anySatisfy: [:selected | selected]! !

!CityVisualization methodsFor: 'displaying' stamp: 'DouailleErwan 4/24/2012 11:33'!
helpDisplay
	|dialog builder window|
	window := UITheme .
	builder := window exampleBuilder.
	dialog := (builder newPluggableDialogWindow: 'Help !!') useDefaultOKButton.
	dialog contentMorph: (
		(dialog newRow: {
				(dialog newTextEditorFor: (ValueHolder new contents: 'SourceCity Information',Character cr asString,'Shortcut keyboard :') 
				getText: #contents 
				setText: #contents:) minWidth: 300;minHeight: 600;disable .
			})vResizing: #spaceFill); model: nil.
	builder openModal: dialog! !

!CityVisualization methodsFor: 'initialize-release' stamp: 'DouailleErwan 5/11/2012 16:22'!
initialize
	|tmp|
	tmp :=OrderedCollection new.
	tmp addAll: ((RPackageOrganizer default packageNames) sort: [:a :b | a name < b name]).
	self unselectedItems: OrderedCollection new.
	self selectedItems: tmp.
	selectedSelectionList := Dictionary new.
	unselectedSelectionList := Dictionary new.
	win := StandardWindow new.
	cityColor := win newHSVSelector: (Color r: 0.6 g: 0.6 b: 0.6) 
		help: 'This is a hue-saturation-volume selector'.
	districtColor := win newHSVSelector: (Color r: 0.8 g: 0.8 b: 0.8)
		help: 'This is a hue-saturation-volume selector'.
	districtGap := ValueHolder new contents: '2'.
	buildingLowColor := win newHSVSelector: (Color r: 0 g: 0 b: 1)
		help: 'This is a hue-saturation-volume selector'.
	buildingMediumColor := win newHSVSelector: (Color  r: 0 g: 1 b: 0)
		help: 'This is a hue-saturation-volume selector'.
	buildingHighColor := win newHSVSelector: (Color  r: 1 g: 0 b: 0)
		help: 'This is a hue-saturation-volume selector'.
	buildingGap := ValueHolder new contents: '2'.
	buildingMediumHeightColor := ValueHolder new contents: '20'.
	buildingMaxHeightColor := ValueHolder new contents: '50'.
	buildingMaxWidthColor := ValueHolder new contents: '5'.
	buildingHeightCalcList := ListModel new list: #('sqrt' 'ln' 'log' 'none');selectionIndex:2.
	buildingWidthCalcList := ListModel new list: #('sqrt' 'ln' 'log' 'none');selectionIndex:2.
	glBackground := win newHSVSelector: (Color r: 1 g: 1 b: 1)
		help: 'This is a hue-saturation-volume selector'.
	glAAList := ListModel new list: #('FASTEST' 'NICEST');selectionIndex:1.
	glPerspectiveList := ListModel new list: #('FASTEST' 'NICEST');selectionIndex:1.
	cameraXPos := ValueHolder new contents: '-196'.
	cameraYPos := ValueHolder new contents: '-15'.
	cameraZPos := ValueHolder new contents: '0'.
	self display! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
listPackages
	
	^ listPackages! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
listPackages: anObject
	
	listPackages := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 09:57'!
model
	^ model! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 09:57'!
model: anObject
	model := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:50'!
openGL
	
	^ openGL! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
openGL: anObject
	
	openGL := anObject! !

!CityVisualization methodsFor: 'displaying' stamp: 'DouailleErwan 5/11/2012 16:18'!
openGLTab
		^(win newRow:{
				win newGroupbox: 'Color settings' forAll:{
					(win newTitle: 'Background color' for: ((glBackground) minHeight: 80; minWidth: 120)).}.
					win newGroupbox: 'Camera default position settings' forAll:{
					(win newTitle: 'x' for: (
						(win newTextEntryFor:  (cameraXPos)
							getText: #contents
							setText:  #contents:
							help: 'insert an Integer'))).
					(win newTitle: 'y' for: (
						(win newTextEntryFor:  (cameraYPos)
							getText: #contents 
							setText:  #contents:
							help: 'insert an Integer'))).
					(win newTitle: 'z' for: (
						(win newTextEntryFor:  (cameraZPos)
							getText: #contents 
							setText:  #contents:
							help: 'insert an Integer'))).
				}.
				win newGroupbox: 'OpenGL environment settings' forAll:{
					(win newTitle: 'Enable/disable Light' for: (
						(win newCheckboxFor: (ValueHolder new contents: true)
						getSelected: #contents setSelected: #contents: label: 'Light' help: 'This is a checkbox'))).
					(win newTitle: 'Enable/disable Light' for: (
						(win newCheckboxFor: (ValueHolder new contents: true)
						getSelected: #contents setSelected: #contents: label: 'Shadow' help: 'This is a checkbox'))).
					(win newTitle: 'Anti analysing performance' for: (
						(win newDropListFor: (glAAList)
							list: #list 
							getSelected: #selectionIndex 
							setSelected: #selectionIndex: 
							help: 'Method of calcul for better visualization'))).
					(win newTitle: 'Perspective performance' for: (
						(win newDropListFor: (glPerspectiveList)
							list: #list 
							getSelected: #selectionIndex 
							setSelected: #selectionIndex: 
							help: 'Method of calcul for better visualization'))).
					}
				})! !

!CityVisualization methodsFor: 'displaying' stamp: 'DouailleErwan 5/4/2012 10:08'!
packageTab
		^(win newRow:{
				win newGroupbox: 'Unselected packages' for: (win newColumn: {
						self buildUnselectedItemsList.}).
				(win newGroupboxFor: (
					(win newColumn: {
						self buildAddAllButton.
						self buildAddButton.
						self buildRemoveButton.
						self buildRemoveAllButton})
						vResizing: #shrinkWrap))
					vResizing: #shrinkWrap.
				win newGroupbox: 'Selected packages' for: (win newColumn: {
						self buildSelectedItemsList.}).
				})vResizing: #spaceFill;hResizing: #spaceFill! !

!CityVisualization methodsFor: 'action-CityConfiguration' stamp: 'DouailleErwan 4/26/2012 11:04'!
refreshActivity
	(glCity isNil)
	ifFalse: [
		glCity changeConfiguration: self cityConfigurationBuild.
		].
	! !

!CityVisualization methodsFor: 'action-List' stamp: 'DouailleErwan 5/3/2012 11:14'!
removeAllButtonAction
	self removeAllItems.! !

!CityVisualization methodsFor: 'action-List' stamp: 'DouailleErwan 5/3/2012 11:09'!
removeAllButtonState
	^false! !

!CityVisualization methodsFor: 'action-List' stamp: 'DouailleErwan 5/7/2012 10:40'!
removeAllItems
	self unselectedItems addAll: self selectedItems.
	self selectedItems removeAll.
	selectedSelectionList removeAll.
	self selectedSelectionIndex: 0.
	self
		changed: #selectedItems;
		changed: #hasSelectedItems;
		changed: #hasSelectedSelections;
		changed: #unselectedItems;
		changed: #hasUnselectedItems.! !

!CityVisualization methodsFor: 'action-List' stamp: 'DouailleErwan 5/3/2012 11:13'!
removeButtonAction
	self removeSelectedItems.! !

!CityVisualization methodsFor: 'action-List' stamp: 'DouailleErwan 5/3/2012 11:09'!
removeButtonState
	^false! !

!CityVisualization methodsFor: 'action-List' stamp: 'DouailleErwan 5/7/2012 10:40'!
removeSelectedItems
	self unselectedItems addAll:  self selectedSelectionItems..
	self selectedItems removeAll: self selectedSelectionItems..
	selectedSelectionList removeAll.
	self selectedSelectionIndex: 0.
	self
		changed: #selectedItems;
		changed: #hasSelectedItems;
		changed: #hasSelectedSelections;
		changed: #unselectedItems;
		changed: #hasUnselectedItems.! !

!CityVisualization methodsFor: 'selectedList' stamp: 'DouailleErwan 5/3/2012 10:56'!
selectedItems
	^selectedItems! !

!CityVisualization methodsFor: 'selectedList' stamp: 'DouailleErwan 5/3/2012 10:56'!
selectedItems: anOrderedCollection 
	
	selectedItems := anOrderedCollection.! !

!CityVisualization methodsFor: 'selectedList' stamp: 'DouailleErwan 5/3/2012 11:02'!
selectedSelectionAt: index

	^selectedSelectionList at: index ifAbsent: [false]! !

!CityVisualization methodsFor: 'selectedList' stamp: 'DouailleErwan 5/3/2012 11:02'!
selectedSelectionAt: index put: aBoolean
	"Mark the item as selected or not."
	
	selectedSelectionList at: index put: aBoolean.
	self changed: #hasSelectedSelections! !

!CityVisualization methodsFor: 'selectedList' stamp: 'DouailleErwan 5/3/2012 11:00'!
selectedSelectionIndex
	selectedSelectionIndex ifNil: [selectedSelectionIndex := 0].
	^selectedSelectionIndex! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/11/2012 16:23'!
selectedSelectionIndex1
	^ selectedSelectionIndex! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/11/2012 16:23'!
selectedSelectionIndex1: anObject
	^ selectedSelectionIndex := anObject! !

!CityVisualization methodsFor: 'selectedList' stamp: 'DouailleErwan 5/3/2012 11:00'!
selectedSelectionIndex: anObject

	selectedSelectionIndex := anObject.
	self changed: #selectedSelectionIndex! !

!CityVisualization methodsFor: 'selectedList' stamp: 'DouailleErwan 5/3/2012 11:19'!
selectedSelectionItems

	| result |
	result := OrderedCollection new.
	self selectedItems doWithIndex: [:item :index |
		(self selectedSelectionAt: index)
			ifTrue: [result add: item]].
	^result! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/11/2012 16:23'!
selectedSelectionList
	^ selectedSelectionList! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/11/2012 16:23'!
selectedSelectionList: anObject
	selectedSelectionList := anObject! !

!CityVisualization methodsFor: 'action-CityConfiguration' stamp: 'DouailleErwan 4/27/2012 16:07'!
startActivity
	glCity := GLCity new default: self cityConfigurationBuild ;openInWorld.! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:08'!
test
	^'youhou'! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:07'!
test: anObject
	Transcript cr;show:anObject.! !

!CityVisualization methodsFor: 'displaying' stamp: 'DouailleErwan 4/26/2012 11:23'!
toolbar
	^win newToolbar: {
		win newButtonFor: self 
			getState:  nil
			action:  #startActivity
			arguments:  nil
			getEnabled:  nil
			labelForm:  win theme smallDoItIcon 
			help:'Start City view' .
		win newButtonFor: self 
			getState:  nil
			action:  #refreshActivity
			arguments:  nil
			getEnabled:  nil
			labelForm:  win theme smallUpdateIcon 
			help:'Change current configuration' .
			}.! !

!CityVisualization methodsFor: 'unselectedList' stamp: 'DouailleErwan 5/3/2012 10:31'!
unselectedItems
	^unselectedItems! !

!CityVisualization methodsFor: 'unselectedList' stamp: 'DouailleErwan 5/3/2012 10:31'!
unselectedItems: anOrderedCollection 
	
	unselectedItems := anOrderedCollection.! !

!CityVisualization methodsFor: 'unselectedList' stamp: 'DouailleErwan 5/3/2012 13:29'!
unselectedSelectionAt: index

	^unselectedSelectionList at: index ifAbsent: [false]! !

!CityVisualization methodsFor: 'unselectedList' stamp: 'DouailleErwan 5/3/2012 13:29'!
unselectedSelectionAt: index put: aBoolean
	"Mark the item as selected or not."
	
	unselectedSelectionList at: index put: aBoolean.
	self changed: #hasUnselectedSelections! !

!CityVisualization methodsFor: 'unselectedList' stamp: 'DouailleErwan 5/3/2012 10:32'!
unselectedSelectionIndex
	unselectedSelectionIndex ifNil: [unselectedSelectionIndex := 0].
	^unselectedSelectionIndex! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/11/2012 16:23'!
unselectedSelectionIndex1
	^ unselectedSelectionIndex! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/11/2012 16:23'!
unselectedSelectionIndex1: anObject
	^ unselectedSelectionIndex := anObject! !

!CityVisualization methodsFor: 'unselectedList' stamp: 'DouailleErwan 5/3/2012 10:37'!
unselectedSelectionIndex: anObject

	unselectedSelectionIndex := anObject.
	self changed: #unselectedSelectionIndex! !

!CityVisualization methodsFor: 'unselectedList' stamp: 'DouailleErwan 5/3/2012 14:10'!
unselectedSelectionItems

	| result |
	result := OrderedCollection new.
	self unselectedItems doWithIndex: [:item :index |
		(self unselectedSelectionAt: index)
			ifTrue: [result add: item]].
	^result! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/11/2012 16:23'!
unselectedSelectionList
	^ unselectedSelectionList! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/11/2012 16:23'!
unselectedSelectionList: anObject
	unselectedSelectionList := anObject! !

!CityVisualization methodsFor: 'updating' stamp: 'DouailleErwan 4/26/2012 11:07'!
update: aSymbol 
	self refreshActivity! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
win
	
	^ win! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
win: anObject
	
	win := anObject! !
